## tl-cpputils 1.0

=== CMakeLists.txt ===

cmake_minimum_required(VERSION 3.6)

project(tl-cpputils CXX)

# Set the default build type to 'Release'
if (NOT CMAKE_BUILD_TYPE)
	set(default_build_type "Release")
	message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
	set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING "Choose the type of build." FORCE)
endif()

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")

option(TL_CPPUTILS_DOC "Build public API documentation (requires Doxygen)." OFF)
option(TL_CPPUTILS_TESTS "Build tests." OFF)

add_subdirectory(deps)
if(TL_CPPUTILS_DOC)
	add_subdirectory(doc)
endif()
add_subdirectory(src)
if(TL_CPPUTILS_TESTS)
	add_subdirectory(tests)
endif()

=== deps/CMakeLists.txt ===

if(TL_CPPUTILS_TESTS)
	add_subdirectory(googletest)
endif()

=== doc/CMakeLists.txt ===

find_package(Doxygen REQUIRED)

# Variables.
set(DOXYGEN_CFG_IN "doxygen.in")
set(DOXYGEN_CFG "${CMAKE_CURRENT_BINARY_DIR}/doxygen.cfg")
# The trailing '/' after html is significant.
set(DOXYGEN_OUTPUT_DIR "${CMAKE_CURRENT_BINARY_DIR}/html/")

# Properly configure the Doxygen configuration file.
set(DOXYGEN_WARNINGS "NO")
set(DOXYGEN_EXTRACT_PRIVATE "YES")
set(DOXYGEN_EXTRACT_LOCAL_CLASSES "YES")
set(DOXYGEN_INTERNAL_DOCS "YES")
set(DOXYGEN_EXCLUDE_PATTERNS "")
set(DOXYGEN_EXCLUDE_SYMBOLS "")
set(DOXYGEN_ENABLED_SECTIONS "internal")

# Configuration.
configure_file("${DOXYGEN_CFG_IN}" "${DOXYGEN_CFG}" @ONLY)

# Add a target to generate the documentation by running Doxygen.
add_custom_target(doc ALL
	COMMAND ${DOXYGEN_EXECUTABLE} "${DOXYGEN_CFG}"
	SOURCES "${DOXYGEN_CFG}"
	WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
	COMMENT "Generating API documentation with Doxygen" VERBATIM
)

# Cleanup.
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${DOXYGEN_OUTPUT_DIR}")

# Install.
install(DIRECTORY "${DOXYGEN_OUTPUT_DIR}" DESTINATION doc)

=== src/CMakeLists.txt ===

add_subdirectory(tl-cpputils)

=== src/tl-cpputils/CMakeLists.txt ===

set(TL_CPPUTILS_SOURCES
	address.cpp
	alignment.cpp
	byte_value_storage.cpp
	conversion.cpp
	file_io.cpp
	filesystem_path.cpp
	math.cpp
	string.cpp
	system.cpp
	time.cpp
)

if(NOT TARGET tl-cpputils)

	add_library(tl-cpputils STATIC ${TL_CPPUTILS_SOURCES})
	if(MSVC)
		target_link_libraries(tl-cpputils shlwapi) # shlwapi.dll for PathRemoveFileSpec()
	endif()
	target_include_directories(tl-cpputils PUBLIC ${PROJECT_SOURCE_DIR}/include/)

	# Disable the min() and max() macros to prevent errors when using e.g.
	# std::numeric_limits<...>::max()
	# (http://stackoverflow.com/questions/1904635/warning-c4003-and-errors-c2589-and-c2059-on-x-stdnumeric-limitsintmax).
	# Any target that includes "windows.h" needs to define this.
	if(MSVC)
		target_compile_definitions(tl-cpputils PUBLIC NOMINMAX)
	endif()

endif()

=== tests/tl-cpputils/CMakeLists.txt ===

set(TL_CPPUTILS_TESTS_SOURCES
	address_tests.cpp
	alignment_tests.cpp
	array_tests.cpp
	byte_value_storage_tests.cpp
	const_tests.cpp
	container_tests.cpp
	conversion_tests.cpp
	filter_iterator_tests.cpp
	math_tests.cpp
	range_tests.cpp
	scope_exit_tests.cpp
	string_tests.cpp
	time_tests.cpp
	value_tests.cpp
)

if(NOT TARGET tl-cpputils-tests)

	add_executable(tl-cpputils-tests ${TL_CPPUTILS_TESTS_SOURCES})
	target_link_libraries(tl-cpputils-tests tl-cpputils gmock_main)
	install(TARGETS tl-cpputils-tests RUNTIME DESTINATION bin/unit-tests)

endif()

=== debian/changelog ===
tl-cpputils (1.0-1) unstable; urgency=medium

  * Initial release (Closes: #886752)

 -- Yangfl <mmyangfl@gmail.com>  Tue, 09 Jan 2018 21:53:01 +0800

=== debian/control ===
Source: tl-cpputils
Priority: optional
Maintainer: Yangfl <mmyangfl@gmail.com>
Build-Depends:
 debhelper (>= 10),
 cmake (>= 3.6),
Standards-Version: 4.1.3
Section: libs
Homepage: https://github.com/avast-tl/tl-cpputils
Vcs-Git: https://salsa.debian.org/yangfl-guest/tl-cpputils.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/tl-cpputils

Package: libtl-cpputils-dev
Section: libdevel
Architecture: any
Depends: libtl-cpputils1 (= ${binary:Version}), ${misc:Depends}
Description: general C++ utility library used by Avast Threat Labs projects (development files)
 A general C++ utility library used by various Avast Threat Labs projects.
 .
 The library contains several independently usable modules to facilitate work
 with addresses, containers, strings, time, etc.
 .
 This package contains the header files.

Package: libtl-cpputils1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: general C++ utility library used by Avast Threat Labs projects
 A general C++ utility library used by various Avast Threat Labs projects.
 .
 The library contains several independently usable modules to facilitate work
 with addresses, containers, strings, time, etc.

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%tl-cpputils-$1.tar.gz%" \
   https://github.com/avast-tl/tl-cpputils/tags \
   (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
